package com.sun.xml.internal.ws.util;

import java.util.Iterator;
import java.util.Set;
import java.util.HashSet;
import java.util.HashMap;
import com.sun.xml.internal.ws.api.server.SDDocument;
import java.util.Map;
import com.sun.xml.internal.ws.wsdl.SDDocumentResolver;
import com.sun.istack.internal.NotNull;

public class MetadataUtil
{
    public MetadataUtil() {
    }
    
    public static Map<String, SDDocument> getMetadataClosure(@NotNull String systemId, @NotNull SDDocumentResolver resolver, boolean onlyTopLevelSchemas) {
        Map<String, SDDocument> closureDocs = new HashMap();
        Set<String> remaining = new HashSet();
        remaining.add(systemId);
        while (!remaining.isEmpty()) {
            Iterator<String> it = remaining.iterator();
            String current = (String)it.next();
            remaining.remove(current);
            SDDocument currentDoc = resolver.resolve(current);
            SDDocument old = (SDDocument)closureDocs.put(currentDoc.getURL().toExternalForm(), currentDoc);
            assert old == null;
            Set<String> imports = currentDoc.getImports();
            if (!currentDoc.isSchema() || !onlyTopLevelSchemas) {
                for (String importedDoc : imports) {
                    if (closureDocs.get(importedDoc) == null) {
                        remaining.add(importedDoc);
                    }
                    else {
                        continue;
                    }
                }
            }
            else {
                continue;
            }
        }
        return closureDocs;
    }
}
